//+------------------------------------------------------------------+
//|                                             Strength_Polynom.mqh |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+

double indexTable[195];
double valueTable[195];

void init_Strength_Polynome_Table()
{

   indexTable[0] = 0.0;
   indexTable[1] = 0.5;
   indexTable[2] = 1.0;
   indexTable[3] = 1.5;
   indexTable[4] = 2.0;
   indexTable[5] = 2.5;
   indexTable[6] = 3.0;
   indexTable[7] = 3.5;
   indexTable[8] = 4.0;
   indexTable[9] = 4.5;
   
   indexTable[10] = 5.0;
   indexTable[11] = 5.5;
   indexTable[12] = 6.0;
   indexTable[13] = 6.5;
   indexTable[14] = 7.0;
   indexTable[15] = 7.5;
   indexTable[16] = 8.0;
   indexTable[17] = 8.5;
   indexTable[18] = 9.0;
   indexTable[19] = 9.5;
   
   indexTable[20] = 10.0;
   indexTable[21] = 10.5;
   indexTable[22] = 11.0;
   indexTable[23] = 11.5;
   indexTable[24] = 12.0;
   indexTable[25] = 12.5;
   indexTable[26] = 13.0;
   indexTable[27] = 13.5;
   indexTable[28] = 14.0;
   indexTable[29] = 14.5;
   
   indexTable[30] = 15.0;
   indexTable[31] = 15.5;
   indexTable[32] = 16.0;
   indexTable[33] = 16.5;
   indexTable[34] = 17.0;
   indexTable[35] = 17.5;
   indexTable[36] = 18.0;
   indexTable[37] = 18.5;
   indexTable[38] = 19.0;
   indexTable[39] = 19.5;
   
   indexTable[40] = 20.0;
   indexTable[41] = 20.5;
   indexTable[42] = 21.0;
   indexTable[43] = 21.5;
   indexTable[44] = 22.0;
   indexTable[45] = 22.5;
   indexTable[46] = 23.0;
   indexTable[47] = 23.5;
   indexTable[48] = 24.0;
   indexTable[49] = 24.5;
   
   indexTable[50] = 25.0;
   indexTable[51] = 25.5;
   indexTable[52] = 26.0;
   indexTable[53] = 26.5;
   indexTable[54] = 27.0;
   indexTable[55] = 27.5;
   indexTable[56] = 28.0;
   indexTable[57] = 28.5;
   indexTable[58] = 29.0;
   indexTable[59] = 29.5;
   
   indexTable[60] = 30.0;
   indexTable[61] = 30.5;
   indexTable[62] = 31.0;
   indexTable[63] = 31.5;
   indexTable[64] = 32.0;
   indexTable[65] = 32.5;
   indexTable[66] = 33.0;
   indexTable[67] = 33.5;
   indexTable[68] = 34.0;
   indexTable[69] = 34.5;
   
   indexTable[70] = 35.0;
   indexTable[71] = 35.5;
   indexTable[72] = 36.0;
   indexTable[73] = 36.5;
   indexTable[74] = 37.0;
   indexTable[75] = 37.5;
   indexTable[76] = 38.0;
   indexTable[77] = 38.5;
   indexTable[78] = 39.0;
   indexTable[79] = 39.5;
   
   indexTable[80] = 40.0;
   indexTable[81] = 40.5;
   indexTable[82] = 41.0;
   indexTable[83] = 41.5;
   indexTable[84] = 42.0;
   indexTable[85] = 42.5;
   indexTable[86] = 43.0;
   indexTable[87] = 43.5;
   indexTable[88] = 44.0;
   indexTable[89] = 44.5;
   
   indexTable[90] = 45.0;
   indexTable[91] = 45.5;
   indexTable[92] = 46.0;
   indexTable[93] = 46.5;
   indexTable[94] = 47.0;
   indexTable[95] = 47.5;
   indexTable[96] = 48.0;
   indexTable[97] = 48.5;
   indexTable[98] = 49.0;
   indexTable[99] = 49.5;
   
   //
   
   indexTable[100] = 50.0;
   indexTable[101] = 50.5;
   indexTable[102] = 51.0;
   indexTable[103] = 51.5;
   indexTable[104] = 52.0;
   indexTable[105] = 52.5;
   indexTable[106] = 53.0;
   indexTable[107] = 53.5;
   indexTable[108] = 54.0;
   indexTable[109] = 54.5;
   
   indexTable[110] = 55.0;
   indexTable[111] = 55.5;
   indexTable[112] = 56.0;
   indexTable[113] = 56.5;
   indexTable[114] = 57.0;
   indexTable[115] = 57.5;
   indexTable[116] = 58.0;
   indexTable[117] = 58.5;
   indexTable[118] = 59.0;
   indexTable[119] = 59.5;
   
   indexTable[120] = 60.0;
   indexTable[121] = 60.5;
   indexTable[122] = 61.0;
   indexTable[123] = 61.5;
   indexTable[124] = 62.0;
   indexTable[125] = 62.5;
   indexTable[126] = 63.0;
   indexTable[127] = 63.5;
   indexTable[128] = 64.0;
   indexTable[129] = 64.5;
   
   indexTable[130] = 65.0;
   indexTable[131] = 65.5;
   indexTable[132] = 66.0;
   indexTable[133] = 66.5;
   indexTable[134] = 67.0;
   indexTable[135] = 67.5;
   indexTable[136] = 68.0;
   indexTable[137] = 68.5;
   indexTable[138] = 69.0;
   indexTable[139] = 69.5;
   
   indexTable[140] = 70.0;
   indexTable[141] = 70.5;
   indexTable[142] = 71.0;
   indexTable[143] = 71.5;
   indexTable[144] = 72.0;
   indexTable[145] = 72.5;
   indexTable[146] = 73.0;
   indexTable[147] = 73.5;
   indexTable[148] = 74.0;
   indexTable[149] = 74.5;
   
   indexTable[150] = 75.0;
   indexTable[151] = 75.5;
   indexTable[152] = 76.0;
   indexTable[153] = 76.5;
   indexTable[154] = 77.0;
   indexTable[155] = 77.5;
   indexTable[156] = 78.0;
   indexTable[157] = 78.5;
   indexTable[158] = 79.0;
   indexTable[159] = 79.5;
   
   indexTable[160] = 80.0;
   indexTable[161] = 80.5;
   indexTable[162] = 81.0;
   indexTable[163] = 81.5;
   indexTable[164] = 82.0;
   indexTable[165] = 82.5;
   indexTable[166] = 83.0;
   indexTable[167] = 83.5;
   indexTable[168] = 84.0;
   indexTable[169] = 84.5;
   
   indexTable[170] = 85.0;
   indexTable[171] = 85.5;
   indexTable[172] = 86.0;
   indexTable[173] = 86.5;
   indexTable[174] = 87.0;
   indexTable[175] = 87.5;
   indexTable[176] = 88.0;
   indexTable[177] = 88.5;
   indexTable[178] = 89.0;
   indexTable[179] = 89.5;
   
   indexTable[180] = 90.0;
   indexTable[181] = 90.5;
   indexTable[182] = 91.0;
   indexTable[183] = 91.5;
   indexTable[184] = 92.0;
   indexTable[185] = 92.5;
   indexTable[186] = 93.0;
   indexTable[187] = 93.5;
   indexTable[188] = 94.0;
   indexTable[189] = 94.5;
   
   indexTable[190] = 95.0;
   indexTable[191] = 95.5;
   indexTable[192] = 96.0;
   indexTable[193] = 96.5;
   indexTable[194] = 250.0;
   
   valueTable[0] = 0.09065000000;
   valueTable[1] = 0.23189563500;
   valueTable[2] = 0.36947170900;
   valueTable[3] = 0.50068272400;
   valueTable[4] = 0.62577796900;
   valueTable[5] = 0.74732731900;
   valueTable[6] = 0.86080615100;
   valueTable[7] = 0.96888814000;
   valueTable[8] = 1.07180029900;
   valueTable[9] = 1.16976424400;
   
   valueTable[10] = 1.26299625100;
   valueTable[11] = 1.35170731200;
   valueTable[12] = 1.43610319300;
   valueTable[13] = 1.51638449400;
   valueTable[14] = 1.59274670300;
   valueTable[15] = 1.66538025300;
   valueTable[16] = 1.73447058500;
   valueTable[17] = 1.80019819700;
   valueTable[18] = 1.86273870800;
   valueTable[19] = 1.92226291300;
   
   valueTable[20] = 1.97893684000;
   valueTable[21] = 2.03292180700;
   valueTable[22] = 2.08437448100;
   valueTable[23] = 2.13344693500;
   valueTable[24] = 2.18028670300;
   valueTable[25] = 2.22503684100;
   valueTable[26] = 2.26783598100;
   valueTable[27] = 2.30881839200;
   valueTable[28] = 2.34811403400;
   valueTable[29] = 2.38584861500;
   
   valueTable[30] = 2.42214365400;
   valueTable[31] = 2.45711653000;
   valueTable[32] = 2.49088054700;
   valueTable[33] = 2.52354498700;
   valueTable[34] = 2.55521516700;
   valueTable[35] = 2.58599250000;
   valueTable[36] = 2.61538209000;
   valueTable[37] = 2.64467576300;
   valueTable[38] = 2.67335619800;
   valueTable[39] = 2.70150982700;
   
   valueTable[40] = 2.72921946600;
   valueTable[41] = 2.75656436300;
   valueTable[42] = 2.78362026400;
   valueTable[43] = 2.81045946300;
   valueTable[44] = 2.83715086800;
   valueTable[45] = 2.86376004700;
   valueTable[46] = 2.89034929700;
   valueTable[47] = 2.91697769300;
   valueTable[48] = 2.94370114900;
   valueTable[49] = 2.97057247500;
   
   valueTable[50] = 2.99764143500;
   valueTable[51] = 3.02495480100;
   valueTable[52] = 3.05255641500;
   valueTable[53] = 3.08048724400;
   valueTable[54] = 3.10878543500;
   valueTable[55] = 3.13748637900;
   valueTable[56] = 3.16662276100;
   valueTable[57] = 3.19622462200;
   valueTable[58] = 3.22631941400;
   valueTable[59] = 3.25693206000;
   
   valueTable[60] = 3.28808500800;
   valueTable[61] = 3.31979829200;
   valueTable[62] = 3.35208958500;
   valueTable[63] = 3.38497426000;
   valueTable[64] = 3.41846544700;
   valueTable[65] = 3.45257408700;
   valueTable[66] = 3.48730899600;
   valueTable[67] = 3.52267691400;
   valueTable[68] = 3.55868256900;
   valueTable[69] = 3.59532873000;
   
   valueTable[70] = 3.63261627000;
   valueTable[71] = 3.67054421500;
   valueTable[72] = 3.70910980900;
   valueTable[73] = 3.74830856900;
   valueTable[74] = 3.78813433900;
   valueTable[75] = 3.82857935200;
   valueTable[76] = 3.86963428500;
   valueTable[77] = 3.91128831700;
   valueTable[78] = 3.95352918700;
   valueTable[79] = 3.99634324800;
   
   valueTable[80] = 4.03971553000;
   valueTable[81] = 4.08362979200;
   valueTable[82] = 4.12806858400;
   valueTable[83] = 4.17301329900;
   valueTable[84] = 4.21844423600;
   valueTable[85] = 4.26434065300;
   valueTable[86] = 4.31068082800;
   valueTable[87] = 4.35838147200;
   valueTable[88] = 4.40554805700;
   valueTable[89] = 4.45308741700;
   
   valueTable[90] = 4.50097446100;
   valueTable[91] = 4.54918340300;
   valueTable[92] = 4.59768782200;
   valueTable[93] = 4.64646071400;
   valueTable[94] = 4.69547455900;
   valueTable[95] = 4.74470136600;
   valueTable[96] = 4.79411274300;
   valueTable[97] = 4.84367994300;
   valueTable[98] = 4.89337393100;
   valueTable[99] = 4.94316543300;
   
   valueTable[100] = 4.99302500000;
   valueTable[101] = 5.04292306200;
   valueTable[102] = 5.09282998500;
   valueTable[103] = 5.14271613200;
   valueTable[104] = 5.19255191400;
   valueTable[105] = 5.24230785400;
   valueTable[106] = 5.29195464100;
   valueTable[107] = 5.34146318600;
   valueTable[108] = 5.39080468500;
   valueTable[109] = 5.43995066800;
   
   valueTable[110] = 5.48887306400;
   valueTable[111] = 5.53754425400;
   valueTable[112] = 5.58593713100;
   valueTable[113] = 5.63402515400;
   valueTable[114] = 5.68178240900;
   valueTable[115] = 5.72918366300;
   valueTable[116] = 5.77620442600;
   valueTable[117] = 5.82282100300;
   valueTable[118] = 5.86901055400;
   valueTable[119] = 5.91475115300;
   
   valueTable[120] = 5.96002184000;
   valueTable[121] = 6.00480268600;
   valueTable[122] = 6.04907484300;
   valueTable[123] = 6.09282060800;
   valueTable[124] = 6.13602347300;
   valueTable[125] = 6.17866818800;
   valueTable[126] = 6.22074081900;
   valueTable[127] = 6.26222880100;
   valueTable[128] = 6.30312099500;
   valueTable[129] = 6.34340775300;
   
   valueTable[130] = 6.38308096600;
   valueTable[131] = 6.42213412800;
   valueTable[132] = 6.46056238900;
   valueTable[133] = 6.49836261500;
   valueTable[134] = 6.53553344500;
   valueTable[135] = 6.57207534800;
   valueTable[136] = 6.60799067900;
   valueTable[137] = 6.64328374000;
   valueTable[138] = 6.67796083300;
   valueTable[139] = 6.71203032000;
   
   valueTable[140] = 6.74550268000;
   valueTable[141] = 6.77839056600;
   valueTable[142] = 6.81070886200;
   valueTable[143] = 6.84247474200;
   valueTable[144] = 6.87370772600;
   valueTable[145] = 6.90382014900;
   valueTable[146] = 6.93406504600;
   valueTable[147] = 6.96384969300;
   valueTable[148] = 6.99320351600;
   valueTable[149] = 7.02215857200;
   
   valueTable[150] = 7.05074960800;
   valueTable[151] = 7.07901411900;
   valueTable[152] = 7.10699240200;
   valueTable[153] = 7.13472761500;
   valueTable[154] = 7.16226583700;
   valueTable[155] = 7.18965612100;
   valueTable[156] = 7.21695055400;
   valueTable[157] = 7.24420431300;
   valueTable[158] = 7.27147572600;
   valueTable[159] = 7.29882632200;
   
   valueTable[160] = 7.32632089800;
   valueTable[161] = 7.35402756600;
   valueTable[162] = 7.38201781900;
   valueTable[163] = 7.41036658500;
   valueTable[164] = 7.43915228200;
   valueTable[165] = 7.46845687900;
   valueTable[166] = 7.49836595200;
   valueTable[167] = 7.52896874200;
   valueTable[168] = 7.56035821100;
   valueTable[169] = 7.59263110000;
   
   valueTable[170] = 7.62588798600;
   valueTable[171] = 7.66023334100;
   valueTable[172] = 7.69577558800;
   valueTable[173] = 7.73262715800;
   valueTable[174] = 7.77090454800;
   valueTable[175] = 7.81072837900;
   valueTable[176] = 7.85222345100;
   valueTable[177] = 7.89551880400;
   valueTable[178] = 7.94074777200;
   valueTable[179] = 7.98804804200;
   
   valueTable[180] = 8.03756171100;
   valueTable[181] = 8.08943534400;
   valueTable[182] = 8.14382003000;
   valueTable[183] = 8.20087144200;
   valueTable[184] = 8.26074988900;
   valueTable[185] = 8.32362038100;
   valueTable[186] = 8.38965267800;
   valueTable[187] = 8.45902135600;
   valueTable[188] = 8.53190585700;
   valueTable[189] = 8.60849055100;
   
   valueTable[190] = 8.68896478900;
   valueTable[191] = 8.77352296600;
   valueTable[192] = 8.86236457500;
   valueTable[193] = 8.95569426400;
   valueTable[194] = 9000000000000;

}

double getStrengthFromTable( double value)
{

   if (value < indexTable[0])
   {
      return valueTable[0];
   }
   else if (value > indexTable[194])
   {
      return valueTable[194];
   }
   else
   {
      for ( int u = 0; u < ArraySize(indexTable)-1; u++)
      {
         if (value >= indexTable[u] && value < indexTable[u+1])
         {
            return valueTable[u];
         }
      }
   }
   
   return 0.0;

}
